// $Id$
// $URL$
// Provide the XMLHttpRequest class for IE 5.x-6.x:
// RESOURCE = http://en.wikipedia.org/wiki/XMLHttpRequest
if( typeof XMLHttpRequest == "undefined" ) XMLHttpRequest = function() {
  try { return new ActiveXObject("Msxml2.XMLHTTP.6.0") } catch(e) {}
  try { return new ActiveXObject("Msxml2.XMLHTTP.3.0") } catch(e) {}
  try { return new ActiveXObject("Msxml2.XMLHTTP") } catch(e) {}
  try { return new ActiveXObject("Microsoft.XMLHTTP") } catch(e) {}
  throw new Error( "This browser does not support XMLHttpRequest." )
};


/*
More information from http://www.w3.org/TR/XMLHttpRequest/
*/

function extractData(xmlDoc,tagFilter) {
    var rootNode = xmlDoc.documentElement;

    var records = rootNode.childNodes;
    var numRecords = records.length;
    var data = new Array();

    for(var i = 0; i < numRecords; i++) {
	var record = records[i];
	if(!record.tagName || record.tagName != tagFilter)
	    continue;

	var datum = new Object();
	var fields = record.childNodes;
	var numFields = fields.length;
	for(var j = 0; j < numFields; j++) {
	    var field = fields[j];
	    if(!field.tagName)
		continue;

	    if(field.childNodes && field.childNodes[0])
		datum[field.tagName] = field.childNodes[0].nodeValue;
	}
	data.push(datum);
    }
    return data;
}

function presentOpenUrls(node, o) {
    var data = extractData(o.responseXML,'record');

    for(var key in data) {
	var datum = data[key];

	var url = datum.generatedUrl;
	if(!url || url.indexOf('://') == -1){
		var col = datum.collection;
		if (col == "ECO" || col == "JUR" || col == "SOC" || col == "LET" || col == "CIF" || col == "TFL" || col == "BRA" || col == "GES"){
			text = "Available in the open stacks: "
			if (text)
				text += col + " collection "
			var sgn = datum.callNumber;
			if (sgn)
				text += sgn
			node.appendChild(document.createTextNode(text));
		}
		else if (col) {
                	node.appendChild(document.createTextNode("Available in depot: "));
			sgn = datum.callNumber;
			var url = "http://dbiref.uvt.nl/iPort?request=full_record&db=tuts&searchField=sgn&query=" +
				sgn;
			var linkNode = document.createElement("a");
			linkNode.setAttribute("href", url);
			linkNode.setAttribute("target", "_blank");
			text = "Request " + sgn + " from depot";
			linkNode.appendChild(document.createTextNode(text));
			node.appendChild(linkNode);
		}
	}
	else {
		var imageNode = document.createElement("img");
		imageNode.setAttribute("src", "/files/edoc.gif");
		imageNode.setAttribute("alt", "*");
		imageNode.setAttribute("border", "0");
		node.appendChild(imageNode);
		var nbsp = document.createElement("span");
		nbsp.innerHTML = "&nbsp;";
		node.appendChild(nbsp);
      		var linkNode = document.createElement("a");
		linkNode.setAttribute("href", url);
		linkNode.setAttribute("target", "_blank");
		linkNode.appendChild(document.createTextNode(datum.linkMethod));
		node.appendChild(linkNode);
		var br = document.createElement("br");
		node.appendChild(br);
	}
    }
}

function openurl(nodeid, url){
    var node = document.getElementById(nodeid);

    function successHandler(o) {
	presentOpenUrls(node,o);
    }

    function failureHandler(o)
    {
	if (console)
	    console.log('Meresco:openurl XMLHttpRequest statusText: ' + o.statusText );

	node.appendChild(document.createTextNode("Locator unavailable"));
    }

    var request = YAHOO.util.Connect.asyncRequest('GET', url, {
	    success:successHandler,
	    failure:failureHandler,
	    timeout: 15000
	});
};





function getElementsByClass(node,searchClass,tag) {
    var classElements = new Array();
    var els = node.getElementsByTagName(tag); // use "*" for all elements
    var elsLen = els.length;
    var i, j;
    for (i = 0, j = 0; i < elsLen; i++) {
         if (els[i].className == searchClass) {
             classElements[j] = els[i];
             j++;
         }
    }
    return classElements;
}

function handleOpenUrl() {
    var nodes = getElementsByClass(document, "openUrlAnchor", "p");
    for (var i = 0; i < nodes.length; i++) {
        handleOpenUrlForNode(nodes[i]);
    }
}

function handleOpenUrlForNode(aNode) {
    if (aNode.childNodes.length > 0) {
        var url = aNode.childNodes[0].nodeValue
        aNode.removeChild(aNode.childNodes[0]);

        openurl(aNode, url);
    }
}
